; Oldblivion .nsi installer creator script

; The name of the installer
Name "Oldblivion"

; The file to write
Outfile "oldblivion_0.11t7.exe"

; The default installation directory
InstallDir $PROGRAMFILES\Oldblivion

; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM "Software\Oldblivion" "Install_Dir"


Page components
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

Section "Oldblivion (required)"
	ReadRegStr $0 HKLM "Software\Bethesda Softworks\Oblivion" "Installed Path"
	IfErrors 0 installok
	MessageBox MB_OK "Oblivion does not appear to be installed. Please install Oblivion before installing Oldblivion."
	Abort "Missing registry entry."

installok:
	SectionIn RO
	SetOutPath $INSTDIR
	File "oldblivion.exe"
	File "config.exe"
	File "oldblivion.cfg"
	File "README.TXT"
	File "oldblivion.dll"
	File "shaders.sdp"

	; Write the installation path into the registry
	WriteRegStr HKLM SOFTWARE\Oldblivion "Install_Dir" "$INSTDIR"

  	; Write the uninstall keys for Windows
  	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Oldblivion" "DisplayName" "Oldblivion"
  	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Oldblivion" "UninstallString" '"$INSTDIR\uninstall.exe"'
  	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Oldblivion" "NoModify" 1
  	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Oldblivion" "NoRepair" 1
  	WriteUninstaller "uninstall.exe"
	
	Exec '"notepad" $INSTDIR\README.TXT'

SectionEnd


Section "Oblivion Settings (Backs up old)"

	IfFileExists "$DOCUMENTS\My Games\Oblivion\Oblivion.ini" 0 installini
	CopyFiles "$DOCUMENTS\My Games\Oblivion\Oblivion.ini" "$DOCUMENTS\My Games\Oblivion\Oblivion.old.ini"

installini:
	SetOutPath "$DOCUMENTS\My Games\Oblivion"
	File "Oblivion.ini"

SectionEnd


Section "Oblivion Spell Fix Mod"

	ClearErrors
	ReadRegStr $0 HKLM "Software\Bethesda Softworks\Oblivion" "Installed Path"
	IfErrors 0 installok 
	MessageBox MB_OK "Unable to determine Oblivion installation path."
	Return

installok:
	SetOutPath "$0\Data"
	File /r "spellfix\*.*"

SectionEnd


Section "Start Menu Shortcuts"

	SetOutPath $INSTDIR
	CreateDirectory "$SMPROGRAMS\Oldblivion"
	CreateShortCut "$SMPROGRAMS\Oldblivion\Oldblivion.lnk" "$INSTDIR\oldblivion.exe" "" "$INSTDIR\oldblivion.exe" 0
	CreateShortCut "$SMPROGRAMS\Oldblivion\Config.lnk" "$INSTDIR\config.exe" "" "$INSTDIR\config.exe" 0
	CreateShortCut "$SMPROGRAMS\Oldblivion\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0

SectionEnd


Section "Uninstall"

	; Remove registry keys
	DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Oldblivion"
	DeleteRegKey HKLM SOFTWARE\Oldblivion

	; Remove files and uninstaller
	Delete $INSTDIR\oldblivion.exe
	Delete $INSTDIR\config.exe
	Delete $INSTDIR\oldblivion.cfg
	Delete $INSTDIR\README.TXT
	Delete $INSTDIR\oldblivion.dll
	Delete $INSTDIR\shaders.sdp
	Delete $INSTDIR\uninstall.exe
	Delete $INSTDIR\oldblivion.dll.log
	Delete $INSTDIR\oldblivion.exe.log

	; Remove shortcuts, if any
	Delete "$SMPROGRAMS\Oldblivion\*.*"

	; Remove directories used
	RMDir "$SMPROGRAMS\Oldblivion"
	RMDir "$INSTDIR"

	MessageBox MB_YESNO "Do you wish to remove the Oblivion settings installed with Oldblivion as well?" IDYES rmini IDNO skipini
rmini:
	Delete "$DOCUMENTS\My Games\Oblivion\Oblivion.ini"
	CopyFiles "$DOCUMENTS\My Games\Oblivion\Oblivion.old.ini" "$DOCUMENTS\My Games\Oblivion\Oblivion.ini"
	Delete "$DOCUMENTS\My Games\Oblivion\Oblivion.old.ini"
skipini:
	MessageBox MB_OK "If you have installed the spell fix you need to remove it manually from your Oblivion installation directory."

SectionEnd